#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>
#include <time.h>

#define NB_PHILO 5
#define MAX_TIME 10
static int SECONDE = 100000;

sem_t *fourchettes;
sem_t place_libres;

void *philosophe(void *identifiant) {
	int *self = identifiant;
	int left, right;
	int think, eat, hungry;
	printf("P%d: mon numéro est %d \n", *self, *self);
	left = (*self - 1) % NB_PHILO;
	if(left < 0) left = NB_PHILO - 1;
	right = (*self + 1) % NB_PHILO;
	printf("P%d: je dois prendre les fourchettes %d et %d\n", *self, left, right);
	think = ((rand() % MAX_TIME) + 1) * SECONDE;
	eat = ((rand() % MAX_TIME) + 1) * SECONDE;
	hungry = ((rand() % MAX_TIME) + 1) * SECONDE;

	usleep(think);
	sem_wait(& place_libres);
	printf("P%d: j'ai pris place à table\n", *self);

	sem_wait(& fourchettes[left]);
	sem_wait(& fourchettes[right]);
	usleep(eat);
	sem_post(& fourchettes[right]);
	sem_post(& fourchettes[left]);
	sem_post(& place_libres);
	printf("P%d: j'ai fini de manger\n", *self);
	return NULL;
}

int main(void) {
	pthread_t *philosophes;
	int *identifiants;
	int i;
	philosophes = calloc(NB_PHILO, sizeof(pthread_t));
	identifiants = calloc(NB_PHILO, sizeof(int));
	fourchettes = calloc(NB_PHILO, sizeof(sem_t));
	sem_init(& place_libres, 0, NB_PHILO - 1); /* au début, il y a NB_PHILO - 1 places libres à la table */
	srand(time(NULL));
	for(i = 0; i < NB_PHILO; i++) {
		printf(" creation de %d \n", i);
		identifiants[i] = i;
		pthread_create(& philosophes[i], NULL, philosophe, & identifiants[i]);
		sem_init(& fourchettes[i], 0, 1); /* les fourchettes sont initialement libres */
	}
	for(i = 0; i < NB_PHILO; i++) {
		pthread_join(philosophes[i], NULL);
	}
	free(philosophes);
	free(identifiants);
	return 0;
}
