#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>
#include <time.h>

#define ATTENTEMAX 10
#define NAME_LENGTH 100
#define MS 1000

void *ecrivain(void *ptr); /* fonction initiale d'un thread écrivain */
void *lecteur(void *ptr); /* fonction initiale d'un thread lecteur */
int donnee = 0; /* ressource commune à tout le monde */
int ecrivains = 0;
int lecteurs = 0;
int valmax = 0;


int main(int argc, char **argv) {
	/* déclaration des variables */
	int i;
	char *name;
	/* récupération des arguments */
	if(argc < 4) {
		printf("Usage : %s #lecteurs #ecrivains val_max \n", argv[0]);
		return 0;
	}
	lecteurs = atoi(argv[1]);
	ecrivains = atoi(argv[2]);
	valmax = atoi(argv[3]);


	/* initialisation des variables de synchronisation */

	/* initialisation du générateur aléatoire */
	srand(time(NULL)); 

	/* Création de tous les threads */
	for(i = 0; i < lecteurs; i++) {
		name = malloc(sizeof(char) * NAME_LENGTH);
		snprintf(name, NAME_LENGTH, "Lecteur %d", i + 1);
		/* name est un tableau contenant le nom du lecteur */
	}
	for(i = 0; i < ecrivains; i++) {
		name = malloc(sizeof(char) * NAME_LENGTH);
		snprintf(name, NAME_LENGTH, "Ecrivain %d", i + 1);
		/* name est un tableau contenant le nom de l'écrivain */
	}
	return 0;
}

void *ecrivain(void *ptr) {
	char *name = (char*) ptr;
	int attente;
	int donneebis;

	while(donnee < valmax) {
		attente = (int) ((double) rand() * (ATTENTEMAX) / RAND_MAX) + 1;
		usleep(attente * MS);

		printf("%s:\t J'ai envie d'écrire.\n", name);
		/* on entre en section critique et on va boucler tant qu'il y a une lecture en cours ou une écriture en cours */

		attente = (int) ((double) rand() * (ATTENTEMAX) / RAND_MAX) + 1;
		printf("%s:\t À mon tour d'écrire (donnee = %d) ! \n", name, donnee);
		donneebis = donnee;
		usleep(attente * MS);
		donneebis++;
		printf("%s:\t Je rends la main (donnee = %d => %d) \n", name, donnee, donneebis);
		donnee = donneebis;
	}
	printf("%s :\t Au revoir !\n", name);
	free(name);
	return NULL;
}

void *lecteur(void *ptr) {
	char *name = (char*) ptr;
	int attente;
	while(donnee < valmax) {
		attente = (int) ((double) rand() * (3 * ATTENTEMAX) / RAND_MAX) + 1;
		usleep(attente * MS);

		printf("%s :\t J'ai envie de lire !\n", name);
		printf("%s:\t Je commence à lire... \n", name);
		attente = (int) ((double) rand() * (ATTENTEMAX) / RAND_MAX) + 1;
		usleep(attente * MS);
		printf("%s:\t J'ai pu lire la donnée : %d \n", name, donnee);
	}
	printf("%s :\t Au revoir !\n", name);
	free(name);
	return NULL;
}

